#!/bin/bash
if [ $# -lt 5 ]; then
    echo "Use: ./autobuild TARGET_DIRECTORY DATABASE_NAME DATABASE_HOST DATABASE_USER DATABASE_PASS"
    exit
fi
echo "1" > ~/version
cd /projects/instr/cubist/09sp/cse403/cookingspecial/$1/
svn info | grep "Revision:" | awk '{print $2}' > ~/version 
cd .. 
echo "Removing old build ..." 
rm -rf $1/
cd /projects/instr/cubist/09sp/cse403/cookingspecial/
mkdir $1
cd $1/
echo ""
echo "Checking out latest copy ..."
svn checkout -q svn+ssh://attu.cs.washington.edu/projects/instr/09sp/cse403/cse403b/trunk/src/ .
echo ""
echo "Log of changes since last daily build:"
svn log -r BASE:`cat ~/version`
rm ~/version
chgrp -R cse403b *
chmod -R a=rwx *
echo ""
echo "Removing all old tables from test database"
echo -n "USE " > temp_get_tables
echo -n $2 >> temp_get_tables
echo ";" >> temp_get_tables
echo "SHOW TABLES;" >> temp_get_tables
echo -n "USE " > temp_drop_tables
echo -n $2 >> temp_drop_tables
echo ";" >> temp_drop_tables
mysql -p$5 -h $3 -u $4 < temp_get_tables | sed '1d' | sed -e 's/^/DROP TABLE /' | sed -e 's/$/;/' >> temp_drop_tables
mysql -p$5 -h $3 -u $4 < temp_drop_tables
rm temp_get_tables
rm temp_drop_tables
echo ""
echo "Installing database file ..."
links -dump -dump-width 150 "http://cubist.cs.washington.edu/projects/09sp/cse403/cookingspecial/$1/website/www/install.php?submit=1&host=$3&name=$2&user=$4&password=$5&exists=1&populate=1"
echo ""
echo "Running Unit Tests ..."
links -dump -dump-width 150 "http://cubist.cs.washington.edu/projects/09sp/cse403/cookingspecial/$1/website/www/index.php?page=unittest&action=index"
echo ""
echo "Running Parser Tests ..."
bash /projects/instr/cubist/09sp/cse403/cookingspecial/$1/parser/tests/allrecipes_test.sh
