<?php

/* Session Handler abstracts the process of setting and getting cookie and session vars. */
class Session_Handler {
	function setCookie($varname, $value, $expire = 0)
	{
		if (!$varname)
			return false;

		return setcookie($varname, $value, $expire);
	}

	function getCookie($varname)
	{
		if (isset($_COOKIE[$varname])) {
			return $_COOKIE[$varname];
		} else {
			return null;
		}
	}

	function setSession($varname, $value)
	{
		if ($varname && $this->start()) {
			$_SESSION[$varname] = $value;
			return true;
		} else {
			return false;
		}
	}

	function getSession($varname)
	{
		if ($varname && $this->start()) {
			if (isset($_SESSION[$varname])) {
				return $_SESSION[$varname];
			} else {
				return null;
			}
		}
	}

	private function start() {
		if (!session_id()) {
			return session_start();
		} else {
			return true;
		}
	}
}

?>