<?php

// set error reporting threshold to E_ERROR.
error_reporting(E_ERROR);

// If we are handling a form that has been submitted, process the install using the form data.
// Otherwise, we are handling a new install: show the install form with default parameters.

$install = new Installer();
if (isset($_REQUEST['submit'])) {
	$install->processInstall();
} else {
	$install->displayInstallForm();
}


class Installer {
	var $smarty;
	function __construct() {
		$_libdir = '../lib/';

		require($_libdir . 'smarty/libs/Smarty.class.php');
		$smarty = new Smarty();

		$smarty->compile_dir = $_libdir . '/smarty/templates_c/';
		$smarty->config_dir = $_libdir . '/smarty/configs/';
		$smarty->cache_dir = $_libdir . '/smarty/cache/';
		$smarty->template_dir = './install_include/';

		$this->smarty = $smarty;
	}

	// process the result of an install form submit. Perform all actions necessary to setup the CookingSpecial database.
	function processInstall() {
		// validate the form information by trying to connect with the given information.
		$host = $_REQUEST['host'];
		$name = $_REQUEST['name'];
		$user = $_REQUEST['user'];
		$password = $_REQUEST['password'];
		$exists = isset($_REQUEST['exists']) && $_REQUEST['exists'];
		$populate = isset($_REQUEST['populate']) && $_REQUEST['populate'];

		// connect to the database using host, username, and password.
		$connection = mysql_connect($host, $user, $password);
		if (!$connection) {
			// return to initial page if there was an error connecting.
			$this->smarty->append('messages', 'Could not connect to the database with the given host, user, and password.');
			$this->smarty->append('messages', mysql_error());
			$this->displayInstallForm($host, $name, $user, $password, $exists, $populate);
			return;
		}

		if ($exists) {
			// remove the database to be replaced with a new copy.
			if (!mysql_query("DROP DATABASE {$name}", $connection)) {
				$this->smarty->append('messages', 'Could not drop the existing database so that it could be replaced.');
				$this->smarty->append('messages', mysql_error());
				$this->displayInstallForm($host, $name, $user, $password, $exists, $populate);
				return;
			}
		}

		// create the database if it doesn't exist
		if (!mysql_query("CREATE DATABASE {$name}", $connection)) {
			$this->smarty->append('messages', 'Could not create database ' . $name);
			$this->smarty->append('messages', mysql_error());
			$this->displayInstallForm($host, $name, $user, $password, $exists, $populate);
			return;
		}

		// select database
		if (!mysql_select_db($name, $connection)) {
			$this->smarty->append('messages', 'Could not select database ' . $name);
			$this->smarty->append('messages', mysql_error());
			$this->displayInstallForm($host, $name, $user, $password, $exists, $populate);
			return;
		}

		// create  tables
		$script = file_get_contents('../lib/sql/script_create_tables.sql');
		$queries = explode(';', $script);
		foreach ($queries as $query) {
			$query = trim($query);
			if ($query && !mysql_unbuffered_query($query, $connection)) {
				$this->smarty->append('messages', 'Could not create tables successfully.');
				$this->smarty->append('messages', "Query: {$query}");
				$this->smarty->append('messages', mysql_error());
				$this->displayInstallForm($host, $name, $user, $password, $exists, $populate);
				return;
			}
		}

		if ($populate) {
			// populate the database with example data
			$script = file_get_contents('../lib/sql/script_insert_data.sql');
			$queries = explode(';', $script);
			foreach ($queries as $query) {
				$query = trim($query);
				if ($query && !mysql_unbuffered_query($query, $connection)) {
					$this->smarty->append('messages', 'Could not populate the database with default values.');
					$this->smarty->append('messages', mysql_error());
					$this->displayInstallForm($host, $name, $user, $password, $exists, $populate);
					return;
				}
			}
		}

		// if we get to this point successfully, update the config file in tinymvc configs folder.
		$this->createConfig($host, $name, $user, $password);
	}

	// display the install form using the given form information.
	function displayInstallForm($host = null, $name = null, $user = null, $password = null, $exists = null, $populate = null) {
		// if fields are not given, output current config values to form as default fields.
		$config_file = '../lib/tinymvc/myapp/configs/database.php';
		if (file_exists($config_file)) {
			require_once($config_file);
			if ($host == null) $host = $config['host'];
			if ($name == null) $name = $config['name'];
			if ($user == null) $user = $config['user'];
			if ($password == null) $password = $config['pass'];
			if ($exists == null) $exists = false;
			if ($populate == null) $populate = true;
		}

		$this->smarty->assign('host', $host);
		$this->smarty->assign('name', $name);
		$this->smarty->assign('user', $user);
		$this->smarty->assign('password', $password);
		$this->smarty->assign('exists', $exists);
		$this->smarty->assign('populate', $populate);

		// display install form
		$this->smarty->display('install_form.tpl');
	}

	// create the config file and write to database.php, given the host, name, user, and password. 
	// Output to the user if the existing database.php cannot be overwritten.
	function createConfig($host, $name, $user, $password) {
		$this->smarty->assign('host', $host);
		$this->smarty->assign('name', $name);
		$this->smarty->assign('user', $user);
		$this->smarty->assign('password', $password);

		// create database.php (config) content string
		$config_content = $this->smarty->fetch('database_config.tpl');

		if (file_put_contents('../lib/tinymvc/myapp/configs/database.php', $config_content)) {
			$this->smarty->display('install_complete.tpl');
		} else {
			// if we couldn't write the contents, output the results directly to the user's screen.
			$this->smarty->assign('other', 'Please copy this file into the lib/tinymvc/configs/ folder.');
			$config_content = $this->smarty->fetch('database_config.tpl');

			echo "<pre>";
			echo $config_content;
			echo "</pre>";
		}
	}
}

?>